//Including the libaries
#include <Wire.h>
#include <LiquidCrystal_I2C.h>

//Defining the LCD Display
LiquidCrystal_I2C lcd(0x27, 16, 2);



//Joystick pin numbers
const int swVal = 2; //Switch -> pin 2
const int xVal = 0;  //X Axis -> A0
const int yVal = 1;  //Y Axis -> A1

//LED pin numbers
int up = 7;
int down = 8;
int pass = 3;
int df1 = 4;
int df2 = 5;
int df3 = 6;

//Reset push button pin number
int ress = 12;

int passN = 0;


//Game over bool value
bool GO = false;



//Ship display graphics
byte ship[] = {
  B00000,
  B11000,
  B11100,
  B11111,
  B11111,
  B11100,
  B11000,
  B00000
};

//Astroid display graphics
byte astr[] = {
  B00000,
  B00000,
  B00000,
  B11111,
  B11111,
  B00000,
  B00000,
  B00000
};



//Declaring the starting values of the astroids
//Astroid 1
int astrX = 16;
int astrY = rand() % 2;

//Astroid 2
int astrX2 = astrX + 3 + rand() % 8;
int astrY2 = rand() % 2;


//Declaring the starting values of the ship
int shipX = 3;
int shipY = 1;


//Declaring a bool values of when ships and astroid shoud move (including when functions should run)
bool move = true;



//Start of moveAstr function
//Moving the astroid 1 block to the left every 0.5 seconds

//How much time has past since the last move
unsigned long previousMillis = 0; //unsigned long stores only positive values from 0 - 4,294,967,295


//How much time should pass to move
long interval = 65;


void moveAstr() {
 
  //Running the function if move is true
  if (move) {

    //Checking if 0.5 seconds have passed
    unsigned long currentMillis = millis(); //millis(); is how many milliseconds have passed since the arduino was turned on
    if (currentMillis - previousMillis >= interval) {

      //Storing previousMillis into currentMillis
      previousMillis = currentMillis;

           //Printing a empty space on the positon of the astroid
      lcd.setCursor(astrX, astrY);
      lcd.print(" ");
      lcd.setCursor(astrX2, astrY2);
      lcd.print(" ");


      //Subtracing the X value by 1
      astrX--;
      astrX2--;


      //If the astroid is off the screen, move it on the starting point
      if (astrX < 0) {
        astrX = 16;
        astrY = rand() % 2;
      }
      if (astrX2 < 0) {
        while (astrX2 <15){
          astrX2 = astrX + 3 + rand() % 8;
        }
        astrY2 = rand() % 2;
      }

 
     
      //Setting the astroid to the new X value
      lcd.setCursor(astrX, astrY);
      lcd.write(1);
      lcd.setCursor(astrX2, astrY2);
      lcd.write(1);
//      lcd.setCursor(astrX3, astrY3);
//      lcd.write(1);

     
    }
  }
}

//End of moveAstr function



//Difficulty functions
void deff() {
  if(move){
  if (passN == 24) {
    interval = 35;
    digitalWrite(df1, HIGH);
  }
 }
}


void deff2() {
  if(move){
  if (passN == 48) {
    //interval = 20;
    analogWrite(df2, 255);
  }
 }
}


void deff3() {
  if(move){
  if (passN == 72) {
    //interval = 10;
    analogWrite(df3, 255);
  }
 }
}



//If the astroid(s) and the ship have the same X and Y values, play the Game OVER! screen - Gameover function
void gameOver() {
  if (shipX == astrX && shipY == astrY || shipX == astrX2 && shipY == astrY2) {
  move = false;
  GO = true;
  passN = 9;
  digitalWrite(df1, LOW);
  analogWrite(df2, 0);
  analogWrite(df3, 0);
  interval = 50;
  lcd.clear();
  lcd.setCursor(3, 0);
  lcd.print("Game OVER!");
  }
}


//If the joystick is pulled up, move the ship 1 block up - upJ function
void upJ() {
  if (move && analogRead(yVal) >= 1000) {
    digitalWrite(up, HIGH);
    delay(1);
    digitalWrite(up, LOW);
    lcd.setCursor(shipX, shipY);
    lcd.print(" ");
    shipY = 0;
    lcd.setCursor(shipX, shipY);
    lcd.write(0);
  }
}


// If the joystick is pulled down, move the ship 1 block down - downJ function
void downJ() {
  if (move && analogRead(yVal) <= 10) {
    digitalWrite(down, HIGH);
    delay(1);
    digitalWrite(down, LOW);
    lcd.setCursor(shipX, shipY);
    lcd.print(" ");
    shipY = 1;
    lcd.setCursor(shipX, shipY);
    lcd.write(0);
  }
}





//If the switch is pressed, reset the game - reset function
void reset() {
 
  delay(1000);
  lcd.clear();
  lcd.setCursor(3, 1);
  lcd.print("Game RESET");
  delay(1000);
  lcd.clear();

  passN = 0;
  digitalWrite(df1, LOW);
  analogWrite(df2, 0);
  analogWrite(df3, 0);
  interval = 50;
 
  shipX = 3;
  shipY = 1;
  astrX = 16;
  astrY = rand() % 2;

//Astroid 2
   astrX2 = astrX + 3 + rand() % 8;
   astrY2 = rand() % 2;


   lcd.createChar(1, astr);
   lcd.setCursor(astrX, astrY);
   lcd.write(1);
   lcd.clear();
   lcd.init();
   lcd.backlight();
   lcd.setCursor(3, 1);
   lcd.write(0);
 
   move = true;
   GO = false;
}


//When the astroids pass the ship, light up LED pass - passAS function
void passAS() {
  if(move){
  if(astrX == shipX || astrX2 == shipX){
    digitalWrite(pass, HIGH);
    passN = passN + 1;
    Serial.print("Pass:");
    Serial.println(passN);
  }
  else if(astrX > shipX || astrX2 > shipX) {
    digitalWrite(pass, LOW);
  }
}
}

void setup() {
  Serial.begin(9600);
  //Declaring the joystick as an input
  lcd.init();
  lcd.backlight();
 
  pinMode(swVal, INPUT);
  //digitalWrite(swVal, HIGH);
  Serial.begin(9600);
 
  //Declaring the LEDS as outputs
  pinMode(up, OUTPUT);
  pinMode(down, OUTPUT);
  pinMode(pass, OUTPUT);
  pinMode(ress, INPUT);
  pinMode(df1, OUTPUT);


  //Writing the ship and astroid in the starting positions
  if (move){
    lcd.init();
    lcd.backlight();
    lcd.createChar(0, ship);
    lcd.setCursor(3, 1);
    lcd.write(0);
    lcd.createChar(1, astr);
    lcd.setCursor(astrX, astrY);
    lcd.write(1);
  }
 
  //Setting GO to false again
  GO = false;
}




void loop() {
 
  // Reading the joysticks values on both Axis's and the switch, then printing it to the serial monitor
  Serial.print("Switch:  ");
  Serial.print(digitalRead(swVal));
  Serial.print("\n");
  Serial.print("X-axis: ");
  Serial.print(analogRead(xVal));
  Serial.print("\n");
  Serial.print("Y-axis: ");
  Serial.println(analogRead(yVal));
  Serial.print("\n\n");
  Serial.print(digitalRead(up));
 
  //Running the functions
  if(move){
   moveAstr();
   upJ();
   downJ();
   deff();
   deff2();
   deff3();
  }
 
  //Running the Gameover function
  gameOver();

  //Runnning the passAS function
  passAS();

  //Running the deff function
  
 
  //Running the reset function if ress is pressed
  if (digitalRead(ress) == HIGH) {
    reset();
    Serial.println(digitalRead(ress));
    delay(10);
  }

 
  //Stopping the led from staying on after game over
  if (GO == false){
    passAS();
  }
  else if (GO == true){
    digitalWrite(pass, LOW);
  }





  
}
